#include "FireParameters.h"

namespace GpuThesis {

float FireParameters::getBurningRate() const
{
	return burningRate;
}

void FireParameters::setBurningRate(float burningRate)
{
	this->burningRate = burningRate;
	updateBurningRate(burningRate);
}

float FireParameters::getOutputHeat() const
{
	return outputHeat;
}

void FireParameters::setOutputHeat(float outputHeat)
{
	this->outputHeat = outputHeat;
	updateOutputHeat(outputHeat);
}

float FireParameters::getStoichiometricMixture() const
{
	return stoichiometricMixture;
}

void FireParameters::setStoichiometricMixture(float stoichiometricMixture)
{
	this->stoichiometricMixture = stoichiometricMixture;
	updateStoichiometricMixture(stoichiometricMixture);
}

float FireParameters::getThreshold() const
{
	return threshold;
}

void FireParameters::setThreshold(float threshold)
{
	this->threshold = threshold;
	updateThreshold(threshold);
}

float FireParameters::getExhaustDissipation() const
{
	return exhaustDissipation;
}

void FireParameters::setExhaustDissipation(float exhaustDissipation)
{
	this->exhaustDissipation = exhaustDissipation;
	updateExhaustDissipation(exhaustDissipation);
}

float FireParameters::getFuelDissipation() const
{
	return fuelDissipation;
}

void FireParameters::setFuelDissipation(float fuelDissipation)
{
	this->fuelDissipation = fuelDissipation;
	updateFuelDissipation(fuelDissipation);
}

float FireParameters::getTemperatureDissipation() const
{
	return temperatureDissipation;
}

void FireParameters::setTemperatureDissipation(float temperatureDissipation)
{
	this->temperatureDissipation = temperatureDissipation;
	updateTemperatureDissipation(temperatureDissipation);
}

float FireParameters::getExhaustDiffusion() const
{
	return exhaustDiffusion;
}

void FireParameters::setExhaustDiffusion(float exhaustDiffusion)
{
	this->exhaustDiffusion = exhaustDiffusion;
	updateExhaustDiffusion(exhaustDiffusion);
}

float FireParameters::getTemperatureDiffusion() const
{
	return temperatureDiffusion;
}

void FireParameters::setTemperatureDiffusion(float temperatureDiffusion)
{
	this->temperatureDiffusion = temperatureDiffusion;
	updateTemperatureDiffusion(temperatureDiffusion);
}

float FireParameters::getFuelDiffusion() const
{
	return fuelDiffusion;
}

void FireParameters::setFuelDiffusion(float fuelDiffusion)
{
	this->fuelDiffusion = fuelDiffusion;
	updateFuelDiffusion(fuelDiffusion);
}

float FireParameters::getGravity() const
{
	return gravity;
}

void FireParameters::setGravity(float gravity)
{
	this->gravity = gravity;
	updateGravity(gravity);
}

float FireParameters::getBuoyancy() const
{
	return buoyancy;
}

void FireParameters::setBuoyancy(float buoyancy)
{
	this->buoyancy = buoyancy;
	updateBuoyancy(buoyancy);
}

float FireParameters::getVorticityWeight() const
{
	return vorticityWeight;
}

void FireParameters::setVorticityWeight(float vorticityWeight)
{
	this->vorticityWeight = vorticityWeight;
	updateVorticityWeight(vorticityWeight);
}

float FireParameters::getViscosity() const
{
	return viscosity;
}

void FireParameters::setViscosity(float viscosity)
{
	this->viscosity = viscosity;
	updateViscosity(viscosity);
}

float FireParameters::getVorticity() const
{
	return vorticity;
}

void FireParameters::setVorticity(float vorticity)
{
	this->vorticity = vorticity;
	updateVorticity(vorticity);
}

unsigned int FireParameters::getJacobiSteps() const
{
	return jacobiSteps;
}

void FireParameters::setJacobiSteps(unsigned int jacobiSteps)
{
	this->jacobiSteps = jacobiSteps;
	updateJacobiSteps(jacobiSteps);
}

float FireParameters::getFireColorScale() const
{
	return fireColorScale;
}

void FireParameters::setFireColorScale(float fireColorScale)
{
	this->fireColorScale = fireColorScale;
	updateFireColorScale(fireColorScale);

}

float FireParameters::getSmokeTemperatureScale() const
{
	return smokeTemperatureScale;
}

void FireParameters::setSmokeTemperatureScale(float smokeTemperatureScale)
{
	this->smokeTemperatureScale = smokeTemperatureScale;
	updateSmokeTemperatureScale(smokeTemperatureScale);
}

float FireParameters::getSmokeDensity() const
{
	return smokeDensity;
}

void FireParameters::setSmokeDensity(float smokeDensity)
{
	this->smokeDensity = smokeDensity;
	updateSmokeDensity(smokeDensity);
}

Math::Vector3d FireParameters::getSmokeColor() const
{
	return smokeColor;
}

void FireParameters::setSmokeColor(Math::Vector3d smokeColor)
{
	this->smokeColor = smokeColor;
	updateSmokeColor(smokeColor);
}

float FireParameters::getSmokeVisibilityThreshold() const
{
	return smokeVisibilityThreshold;
}

void FireParameters::setSmokeVisibilityThreshold(float smokeVisibilityThreshold)
{
	this->smokeVisibilityThreshold = smokeVisibilityThreshold;
	updateSmokeVisibilityThreshold(smokeVisibilityThreshold);
}

bool FireParameters::getCompute2dColors() const
{
	return compute2dColors;
}

void FireParameters::setCompute2dColors(bool compute2dColors)
{
	this->compute2dColors = compute2dColors;
	updateCompute2dColors(compute2dColors);
}

float FireParameters::getMassExpansion() const
{
	return massExpansion;
}

void FireParameters::setMassExpansion(float massExpansion)
{
	this->massExpansion = massExpansion;
	updateMassExpansion(massExpansion);
}

Math::Vector3d FireParameters::getGlobalWind() const
{
	return globalWind;
}

void FireParameters::setGlobalWind(Math::Vector3d globalWind)
{
	this->globalWind = globalWind;
	updateGlobalWind(globalWind);
}

Math::Vector3d FireParameters::getGlobalWindAmplitude() const
{
	return globalWindAmplitude;
}

void FireParameters::setGlobalWindAmplitude(Math::Vector3d globalWindAmplitude)
{
	this->globalWindAmplitude = globalWindAmplitude;
	updateGlobalWindAmplitude(globalWindAmplitude);
}

Math::Vector3d FireParameters::getGlobalWindAngle() const
{
	return globalWindAngle;
}

void FireParameters::setGlobalWindAngle(Math::Vector3d globalWindAngle)
{
	this->globalWindAngle = globalWindAngle;
	updateGlobalWindAngle(globalWindAngle);
}

bool FireParameters::getGlobalWindDynamic() const
{
	return globalWindDynamic;
}

void FireParameters::setGlobalWindDynamic(bool globalWindDynamic)
{
	this->globalWindDynamic = globalWindDynamic;
	updateGlobalWindDynamic(globalWindDynamic);
}

}
