#include "Light.h"


namespace GpuThesis {


Light::Light() :
	dynamic(false)
{}

Light::Light(EngineParameters::LightParams light) :
	position(light.position),
	color(light.color * light.intensity),
	dynamic(light.dynamic)
{}

Math::Vector3d Light::getPosition() const
{
	return position;
}

void Light::setPosition(const Math::Vector3d &position)
{
	this->position = position;	
}

Util::Color Light::getColor() const
{
	return color;
}

void Light::setColor(const Util::Color &color)
{
	this->color = color;	
}

bool Light::getDynamic() const
{
	return dynamic;
}

void Light::setDynamic(bool dynamic)
{
	this->dynamic = dynamic;	
}




}
