#include "Material.h"

namespace GpuThesis {
	

Material::Material() :
	ka(0),
	kd(0),
	ks(0),
	shininess(0),
	texture(0),
	hasTexture(false)
{}

Material::Material(EngineParameters::MaterialParams material) :
	ka(material.ka),
	kd(material.kd),
	ks(material.ks),
	shininess(material.shininess),
	texture(0),
	hasTexture(false)
{}

float Material::getKa() const
{
	return ka;
}

void Material::setKa(float ka)
{
	this->ka = ka;	
}

float Material::getKd() const
{
	return kd;
}

void Material::setKd(float kd)
{
	this->kd = kd;	
}

float Material::getKs() const
{
	return ks;
}

void Material::setKs(float ks)
{
	this->ks = ks;	
}

float Material::getShininess() const
{
	return shininess;
}

void Material::setShininess(float shininess)
{
	this->shininess = shininess;	
}

GLuint Material::getTexture() const
{
	return texture;
}

void Material::setTexture(GLuint texture)
{
	this->texture = texture;	
}

bool Material::getHasTexture() const
{
	return hasTexture;
}

void Material::setHasTexture(bool hasTexture)
{
	this->hasTexture = hasTexture;	
}



}
