#ifndef GPUTHESIS_VOLUMETRICEXTRUSION_H
#define GPUTHESIS_VOLUMETRIC_EXTRUSION_H

#include <memory>

#include "Runnable.h"

namespace OpenGL {
	class CgProgram;
	class Flat3dTextureOperation;
	class Flat3dTextureSet;
	class TextureContainer;
}

namespace GpuThesis {

/**
 * Used for debugging.
 */
class VolumetricExtrusion : public Runnable {
public:
	VolumetricExtrusion(OpenGL::Flat3dTextureSet *importTextures,
	                    unsigned int sliceTexture);	                          
	~VolumetricExtrusion();

	OpenGL::TextureContainer *getTextureContainer();
	OpenGL::TextureContainer *getSecondaryTextureContainer();
	OpenGL::Flat3dTextureSet *getTextureSet();

private:
	void initialize(OpenGL::Flat3dTextureSet *importTextures, unsigned int sliceTexture);
	void doRun(float timestep);
	void doReset();	

	std::auto_ptr<OpenGL::Flat3dTextureSet> textures;
	std::auto_ptr<OpenGL::TextureContainer> textureContainer, secondaryContainer;
	
	std::auto_ptr<OpenGL::CgProgram> cgVolumetricExtrusion;
	std::auto_ptr<OpenGL::Flat3dTextureOperation> volumetricExtrusionOp;

	unsigned int volumetricTexture;	
};

}

#endif