#include <exception>
#include <iostream>
#include <memory>
#include <string>

#include "Engine.h"

#include "simple-xml/XmlDocument.h"

int main(int argc, char** argv) {

	std::string xmlFile("configurations/campfire-3d.xml");
	
	if (argc > 1)
		xmlFile = argv[1];
	
	try {

		SimpleXml::XmlDocument doc(xmlFile);

		GpuThesis::Engine engine(doc);		

		return engine.run();
	
	} catch(const std::exception &e) {
		std::cout << "Exception caught: " << e.what() << '\n';		
		return -1;
	}
}