#ifndef GPUTHESIS_TEST_FLUID3DTEST_H
#define GPUTHESIS_TEST_FLUID3DTEST_H

#include "GpuTest.h"

#include "Fluid3dSolver.h"

namespace OpenGL {
class Flat3dTextureSet;
}

namespace Fluid3dSolver {
class FluidFactory;
class Advection;
}

namespace GpuThesis {

namespace Test {

class Advection3dTest : public GpuTest {
public:
	Advection3dTest();
	~Advection3dTest();

private:
	void doRun(float timestep);
	void doReset();

	void setInput();
	void setOuput();

	unsigned int width, height, depth;

	std::auto_ptr<OpenGL::Flat3dTextureSet> textures;
	std::auto_ptr<Fluid3dSolver::FluidFactory> factory;
	
	// Advection Interior
	std::auto_ptr<Fluid3dSolver::Advection> advect;
	unsigned int velocity, value;
	Fluid3dSolver::BoundaryType boundary;
};

class Projection3dTest : public GpuTest {
public:
	Projection3dTest();
	~Projection3dTest();

private:
	void doRun(float timestep);
	void doReset();

	void setInput();
	void setOutput();

	unsigned int width, height, depth;

	std::auto_ptr<OpenGL::Flat3dTextureSet> textures;
	std::auto_ptr<Fluid3dSolver::FluidFactory> factory;

	std::auto_ptr<Fluid3dSolver::Projection> project;
	unsigned int velocity;

	Fluid3dSolver::BoundaryType boundary;
};

}

}

#endif