#include "TestSuite.h"

#include <iostream>
#include <memory>

#include "opengl/OrthonormalProjection.h"

#include "test-suite/GpuTest.h"

namespace GpuThesis {
namespace Test {


TestSuite::TestSuite()
{
}

bool TestSuite::runTests(std::ostream &outputStream)
{
	OpenGL::OrthoNormalProjection ortho;

	bool allSuccessful = true;

	for (std::vector<GpuTest*>::iterator iter = tests.begin(); iter != tests.end(); ++iter) {

		std::auto_ptr<TestResultContainer> result = (*iter)->runTest();

		for (TestResultContainer::const_iterator iter = result->begin(); iter != result->end(); ++iter) {

			outputStream << (*iter)->getDescription() << '\n';

			if (!(*iter)->wasSuccessful())
				allSuccessful = false;
		}
	}

	return allSuccessful;
}

void TestSuite::addTest(GpuTest *test)
{
	tests.push_back(test);
}


}
}

