#ifndef GPUTHESIS_TEST_TESTSUITE_H
#define GPUTHESIS_TEST_TESTSUITE_H

#include <iostream>
#include <vector>

namespace GpuThesis {
namespace Test {

class GpuTest;

/**
 * Class for maintaining and running a set of tests.
 */
class TestSuite {
public:
	TestSuite();	

	/**
	 * Run all the tests, writing the results to the given output stream.
	 * @param outputStream the stream to write the results to.
	 * @return whether all tests were successful.
	 */
	bool runTests(std::ostream &outputStream);

	/**
	 * Add a test to the test suite.
	 * @param test the test to add.
	 */
	void addTest(GpuTest *test);

private:
	std::vector<GpuTest*> tests;
};

}
}

#endif