#include "Model.h"

#include "opengl/Rendering.h"

namespace Geometry {

void Model::render()
{
	for (unsigned int i = 0; i < meshes.size(); ++i)
		OpenGL::displayMesh(meshes[i]);
}

void Model::render(const std::vector<unsigned int> &m)
{
	for (unsigned int i = 0; i < m.size(); ++i)
		if (m[i] < meshes.size())
			OpenGL::displayMesh(meshes[m[i]]);
}

void Model::render(const std::set<unsigned int> &ignoreMeshes)
{
	for (unsigned int i = 0; i < meshes.size(); ++i)
		if (!ignoreMeshes.count(i))
			OpenGL::displayMesh(meshes[i]);
}

unsigned int Model::getVertexCount() const
{
	unsigned int vertexCount = 0;

	for (unsigned int i = 0; i < meshes.size(); ++i)
		vertexCount += static_cast<unsigned int>(meshes[i].vertices.size());

	return vertexCount;
}

}