#ifndef GEOMETRY_MODELLOADER_H
#define GEOMETRY_MODELLOADER_H

#include <string>
#include <map>
#include <memory>

#include <lib3ds/file.h>
#include <lib3ds/mesh.h>
#include <lib3ds/material.h>

#include "Model.h"

#include "util/Color.h"

namespace Geometry {

struct LoadModelFailedException {};

class ModelLoader {
public:
	ModelLoader(const std::string &filename);

	std::auto_ptr<Model> getModel();

private:
	struct Material {
		Util::Color ambient, diffuse, specular;
	};

	std::auto_ptr<Model> model;

	std::map<std::string, Material> materials;

	void loadMaterials(Lib3dsFile *file);
	void loadMeshes(Lib3dsFile *file);
};

}

#endif