#include <vector>

#include "Image.h"

#include "SDL_image.h"

namespace Image {

Image::Image(const std::string &filename)
{
	data = IMG_Load(filename.c_str());

	if (!data)
		throw LoadImageFailedException();
}



Image::~Image()
{
	SDL_FreeSurface(data);
}



unsigned int Image::getWidth() const
{
	return static_cast<unsigned int>(data->w);
}



unsigned int Image::getHeight() const
{
	return static_cast<unsigned int>(data->h);
}



unsigned int Image::getBpp() const
{
	return static_cast<unsigned int>(data->format->BytesPerPixel);
}



unsigned char *Image::getData() const
{
	return static_cast<unsigned char *>(data->pixels);
}

}