#include "BoundingBox.h"

#include <iostream>

namespace Math {

BoundingBox::BoundingBox()
{
}

BoundingBox::BoundingBox(Vector3d minV, Vector3d maxV) :
	minV(minV), maxV(maxV)
{
}

Vector3d BoundingBox::getMin() const
{
	return minV;
}

Vector3d BoundingBox::getMax() const
{
	return maxV;
}

void BoundingBox::setMin(const Vector3d &v)
{
	minV = v;
}

void BoundingBox::setMax(const Vector3d &v)
{
	maxV = v;
}

std::ostream &operator<<(std::ostream &out, const BoundingBox &box)
{
	return out << box.getMin() << ' ' << box.getMax();
}

std::istream &operator>>(std::istream &in, BoundingBox &box)
{
	Vector3d min, max;

	in >> min >> max;

	box.setMin(min);
	box.setMax(max);

	return in;
}

}

