#ifndef MATH_BOUNDINGBOX_H
#define MATH_BOUNDINGBOX_H

#include <iosfwd>

#include "Vector3d.h"

/**
 * The Math namespace.
 */
namespace Math {

class BoundingBox {
public:
	BoundingBox();
	BoundingBox(Vector3d min, Vector3d max);

	Vector3d getMin() const;
	Vector3d getMax() const;

	void setMin(const Vector3d &min);
	void setMax(const Vector3d &max);

private:
	Vector3d minV;
	Vector3d maxV;
};

std::ostream &operator<<(std::ostream &out, const BoundingBox &box);
std::istream &operator>>(std::istream &in, BoundingBox &box);

}

#endif