#ifndef MATH_MATRIX3X3
#define MATH_MATRIX3X3

#include <iosfwd>

#include "Definitions.h"

#include "Vector3d.h"

namespace Math {

class Matrix3x3 {
public:
	fp elements[3][3];

	Matrix3x3();
	Matrix3x3(const Matrix3x3& m);
	Matrix3x3::Matrix3x3(fp m[9]);

	Matrix3x3 operator*(const Matrix3x3& m) const;
	Vector3d operator*(const Vector3d& v) const;
	Matrix3x3 operator*(fp f) const;
	Matrix3x3 operator/(fp f) const;

	void setIdentity();
	fp getDeterminant() const;
	Matrix3x3 getInverse() const;
	friend std::ostream& operator<<(std::ostream& out, const Matrix3x3& m);
	void output(std::ostream& out) const;
};

}

#endif
