#ifndef _MATRIX4X4_
#define _MATRIX4X4_

#include <iosfwd>

#include "Definitions.h"
#include "Vector3d.h"
#include "Matrix3x3.h"

namespace Math {

class Matrix4x4 {
	public:
		fp elements[4][4];

		Matrix4x4();
		Matrix4x4(const Matrix4x4& m);
		Matrix4x4(const Matrix3x3& m);
		Matrix4x4(fp m[16], bool rowMajor = true);

		Matrix4x4 operator*(const Matrix4x4& m) const;

		Matrix4x4 operator*(fp f) const;
		Matrix4x4 operator/(fp f) const;

		void getMatrix(float *m, bool rowMajor = true);

		Vector3d multiplyVec3Pos(const Vector3d& v) const;
		Vector3d multiplyVec3Dir(const Vector3d& v) const;

		Matrix3x3 getSubMatrix(int row, int column) const;
		void setIdentity();
		fp getDeterminant() const;
		Matrix4x4 getInverse() const;
		friend std::ostream& operator<<(std::ostream& out, const Matrix4x4& m);
		void output(std::ostream& out) const;
};

}

#endif
