#include "Quaternion.h"

namespace Math {
	
const float *getMatrix(const Quaternion &q)
{
	static float m[4*4] = {0, 0, 0, 0,
	                       0, 0, 0, 0,
	                       0, 0, 0, 0,
	                       0, 0, 0, 1};

	m[0]  = 1 - 2 * (q.y * q.y  + q.z * q.z);
	m[1]  = 2 * (q.x * q.y - q.w * q.z);
	m[2]  = 2 * (q.x * q.z + q.w * q.y);
	
	m[4]  = 2 * (q.x * q.y + q.w * q.z);
	m[5]  = 1 - 2 * (q.x * q.x + q.z * q.z);
	m[6]  = 2 * (q.y * q.z - q.w * q.x);

	m[8]  = 2 * (q.x * q.z - q.w * q.y);
	m[9]  = 2 * (q.y * q.z + q.w * q.x);
	m[10] = 1 - 2 * (q.x * q.x + q.y * q.y);
	
	return m;
}

}