#ifndef OPENGL_RENDERING_H
#define OPENGL_RENDERING_H

#include "geometry/fwd.h"

#include <string>

namespace OpenGL {

/**
 * Renders the given mesh to the active display.
 * @param mesh the mesh to be rendered.
 */
void displayMesh(const Geometry::Mesh &mesh);

/**
 * Displays a string to the current framebuffer position.
 * @param font the font to use.
 * @param str the string to be displayed.
 */
void displayString(void *font, const std::string &str);

/**
 * Displays a string of a maximum pixel width to the current framebuffer position.
 * @param font the font to use.
 * @param str the string to be displayed.
 * @param maxWidth the max pixel width of the displayed string.
 */
void displayString(void *font, const std::string &str, unsigned int maxWidth);

}

#endif
