#ifndef SDL_EVENTHANDLERIMPL_H
#define SDL_EVENTHANDLERIMPL_H

#include "SDL.h"

#include <map>
#include <memory>
#include <set>

/**
 * The SDL namespace.
 */
namespace SDL {

class EventHandler;

class EventHandlerImpl {
public:
	EventHandlerImpl(bool repeat);

	void handleEvents(EventHandler *handler, float timedelta);
	bool isPressed(unsigned char key) const;

private:
	void handleRepeat(EventHandler *handler, float timedelta);

	unsigned char getCharCode(const SDL_Event &event) const;

	std::map<SDLKey, unsigned char> keySymMap;
	SDLKey activeKey;

	bool pressed[256];

	void dispatchKeyPress(EventHandler *handler, const SDLKey &key);

	bool repeat;
	bool repeatActive;

	float timeLeft;
};

}

#endif