#ifndef SDL_EVENTS_H
#define SDL_EVENTS_H

#include <memory>

namespace SDL {

class EventHandlerImpl;

enum SpecialKeys {
	KEY_UP = 128,
	KEY_DOWN,
	KEY_LEFT,
	KEY_RIGHT
};

class EventHandler {
public:
	EventHandler(bool repeat = false);
	virtual ~EventHandler();

	void handleEvents(float timedelta = 0.0f);
	bool isPressed(unsigned char key) const;

private:
	std::auto_ptr<EventHandlerImpl> impl;

	virtual void quit() = 0;

	virtual void handleChar(char key) = 0;

	virtual void handleEnter() = 0;
	virtual void handleBackspace() = 0;
	virtual void handleTab() = 0;
	virtual void handleUpArrow() = 0;
	virtual void handleDownArrow() = 0;

	friend EventHandlerImpl;
};

}

#endif
