#ifndef SDL_OPENGLCONTEXT_H
#define SDL_OPENGLCONTEXT_H

#include <string>

struct SDL_Surface;

namespace SDL {

class OpenGLContext {
public:
	OpenGLContext(unsigned int width, unsigned int height,
	              const std::string &caption,
	              bool fullscreen = false);

	~OpenGLContext();

	bool good() const;
  
	bool lock() const;
	void unlock() const;

	void flip() const;

private:
	static bool taken;

	SDL_Surface *screen;
};

}

#endif
