#include "Timer.h"

#include "SDL.h"

namespace SDL {

Timer::Timer() : startTime(SDL_GetTicks())
{
}


float Timer::seconds() const
{
  return (SDL_GetTicks() - startTime) * 0.001f;
}


void Timer::sleep(float seconds)
{
  SDL_Delay(static_cast<unsigned int>(seconds * 1000.0f));
}


void Timer::reset()
{
	startTime = SDL_GetTicks();
}

}
