#ifndef SIMPLEXML_XMLNODE_H
#define SIMPLEXML_XMLNODE_H

#include <string>

namespace SimpleXml {

class XmlNode {
public:
	XmlNode(const std::string &name);

	XmlNode* getParent();
	XmlNode* getFirstChild();
	XmlNode* getFirstChild(const std::string &nodeName);
	XmlNode* getNextSibling();
	XmlNode* getNextSibling(const std::string &nodeName);
	const std::string& getName() const;
	const std::string& getValue() const;
	void setValue(const std::string &value);
	XmlNode* appendChild(const std::string &childName);
	bool hasChildNodes() const;

private:
	XmlNode *parent;
	XmlNode *firstChild;
	XmlNode *lastChild;
	XmlNode *nextSibling;
	XmlNode *previousSibling;

	std::string name;
	std::string value;
};

}

#endif