#ifndef PERLIN_H
#define PERLIN_H

#include <map>
#include <utility>

class Perlin2D {
public:
  Perlin2D(unsigned int numOctaves, float persistence, int seed = 0);
 
  float sample(float x, float y) const;

private:
  float random(int x, int y, unsigned int octave) const;
  float smoothedRandom(int x, int y, unsigned int octave) const;
  float interpolate(float a, float b, float fraction) const;
  float interpolateNoise(float x, float y, unsigned int octave) const;

  unsigned int mNumOctaves;
  float mPersistence;
  int mSeed;
};

class Perlin1D {
public:
	Perlin1D(unsigned int numOctaves, float persistence, int seed = 0);

	float sample(float x) const;

private:
	float random(int x, unsigned int octave) const;
	float smoothedRandom(int x, unsigned int octave) const;
	float interpolate(float a, float b, float fraction) const;
	float interpolateNoise(float x, unsigned int octave) const;

	unsigned int mNumOctaves;
	float mPersistence;
	int mSeed;
};

#endif
